<?php
// Let's go

// Path to our theme's directory
define( 'TEMPPATH', get_bloginfo('stylesheet_directory'));
// Path to our image folder
define( 'IMAGES', TEMPPATH. "/images");


// Stop adding p tags to my wysiwyg, yo!
remove_filter('the_content', 'wpautop');


/* Google Analytics */
add_action('wp_head', 'google_analytics');

function google_analytics() { ?>
	<script type="text/javascript">
	  var _gaq = _gaq || [];
	  _gaq.push(['_setAccount', 'UA-39813348-2']);
	  _gaq.push(['_trackPageview']);

	  (function() {
		var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
		ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
		var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
	  })();
	</script>

<?php
}

/* Remove Foundation Scripts and manually call what we need from Foundation
***************************************************************************/
add_action( 'wp_enqueue_scripts', 'my_deregister_javascript', 100 );
function my_deregister_javascript() {
	wp_deregister_script( 'foundation' );
	wp_deregister_script( 'app' );
	wp_deregister_script( 'jquery' );
}

/* Remove selected Foundation Stylesheets and manually call what we need
***************************************************************************/
add_action( 'wp_print_styles', 'my_deregister_styles', 100 );
function my_deregister_styles() {
	// deregister google fonts call
    wp_deregister_style( 'google-fonts' );
}


/* Load JavaScript Files
***************************************************************************/

// Call external scripts in footer; safe and recommended method (http://codex.wordpress.org/Function_Reference/wp_enqueue_script)
function my_scripts_method() {
	/*
		Register the style like this for a theme:
  	    First the unique name for the script ('myscript') then the src,
  	    then dependencies
  	    then if it should be placed in the footer
	*/


	/* App JavaScript Files
***************************************************************************/
	wp_enqueue_script('jquery.min', get_bloginfo('stylesheet_directory') . '/js/lib/jquery-1.8.3.min.js', array(), '1.8.3', true );
	//wp_enqueue_script('jquery.min', get_bloginfo('stylesheet_directory') . '/js/lib/jquery.min.js', array(), '1.10.0', true );
	wp_enqueue_script('jquery-ui', get_bloginfo('stylesheet_directory') . '/js/lib/jquery-ui_1_9.2.js', array(), '1.9.2', true );
	wp_enqueue_script('jquery.blockUI', get_bloginfo('stylesheet_directory') . '/js/lib/jquery.blockUI.js', array(), '1.9', true );
	wp_enqueue_script('jquery.validate.min', get_bloginfo('stylesheet_directory') . '/js/lib/jquery.validate_1.10.0.min.js', array(), '1.10.0', true );
	wp_enqueue_script('json', get_bloginfo('stylesheet_directory') . '/js/lib/json2.js', array(), '1.9', true );
    wp_enqueue_script('dataTable', get_bloginfo('stylesheet_directory') . '/js/lib/dataTable.js', array(), '1.9', true );
    //wp_enqueue_script('jquery.cookie', get_bloginfo('stylesheet_directory') . '/js/lib/jquery.cookie.js', array(), '1.9', true );
    wp_enqueue_script('jquery.base64', get_bloginfo('stylesheet_directory') . '/js/lib/jquery.base64.js', array(), '1.0.0', true );

	wp_enqueue_script('application', get_bloginfo('stylesheet_directory') . '/js/app/app.js', array(), '1.0.7', true );
	wp_enqueue_script('messages_en', get_bloginfo('stylesheet_directory') . '/js/app/messages_en.js', array(), '1.0.8', true );
	wp_enqueue_script('appconstants', get_bloginfo('stylesheet_directory') . '/js/app/appconstants.js', array(), '1.0.8', true );

	/* Page Level JavaScript Files
***************************************************************************/
	if ( is_page( '6') ) {
		wp_enqueue_script('login', get_bloginfo('stylesheet_directory') . '/js/app/login.js', array(), '1.0.7', true );
		wp_enqueue_script('sendresetpasswordemail', get_bloginfo('stylesheet_directory') . '/js/app/sendresetpasswordemail.js', array(), '1.0.7', true );
	}
	if ( is_page( '9') ) {
		wp_enqueue_script('searchsubmissions', get_bloginfo('stylesheet_directory') . '/js/app/searchsubmissions.js', array(), '1.0.7', true );
		wp_enqueue_script('advancedsearchsubmissions', get_bloginfo('stylesheet_directory') . '/js/app/advancedsearchsubmissions.js', array(), '1.0.7', true );
		wp_enqueue_script('changePassword', get_bloginfo('stylesheet_directory') . '/js/app/changePassword.js', array(), '1.0.7', true );
	}
	if ( is_page( '10') ) {
		wp_enqueue_script('viewsubmission', get_bloginfo('stylesheet_directory') . '/js/app/viewsubmission.js', array(), '1.0.7', true );
        wp_enqueue_script('viewimage', get_bloginfo('stylesheet_directory') . '/js/app/viewimage.js', array(), '1.0.7', true );
		wp_enqueue_script('bfovalidation', get_bloginfo('stylesheet_directory') . '/js/app/bfovalidation.js', array(), '1.0.7', true );
		wp_enqueue_script('submissionhistory', get_bloginfo('stylesheet_directory') . '/js/app/submissionhistory.js', array(), '1.0.7', true );
		wp_enqueue_script('jquery.foundation.reveal', get_bloginfo('stylesheet_directory') . '/js/lib/jquery.foundation.reveal.js', array(), '1.0.7', true );
		wp_enqueue_script('changePassword', get_bloginfo('stylesheet_directory') . '/js/app/changePassword.js', array(), '1.0.7', true );
	}
	if ( is_page( '8') ) {
		wp_enqueue_script('ecpdhistory', get_bloginfo('stylesheet_directory') . '/js/app/ecpdhistory.js', array(), '1.0.7', true );
	}
	if ( is_page( 'resetpassword') ) {
		wp_enqueue_script('resetpassword', get_bloginfo('stylesheet_directory') . '/js/app/resetpassword.js', array(), '1.0.7', true );
	}
	if ( is_page( 'SearchUser') ) {
		wp_enqueue_script('searchuser', get_bloginfo('stylesheet_directory') . '/js/app/searchuser.js', array(), '1.0.7', true );
		wp_enqueue_script('changePassword', get_bloginfo('stylesheet_directory') . '/js/app/changePassword.js', array(), '1.0.7', true );        
	}
	if ( is_page( 'ViewUser') ) {
		wp_enqueue_script('viewuser', get_bloginfo('stylesheet_directory') . '/js/app/viewuser.js', array(), '1.0.7', true );
		wp_enqueue_script('changePassword', get_bloginfo('stylesheet_directory') . '/js/app/changePassword.js', array(), '1.0.7', true );
    }
	if ( is_page( 'EditUser') ) {
		wp_enqueue_script('edituser', get_bloginfo('stylesheet_directory') . '/js/app/edituser.js', array(), '1.0.7', true );
		wp_enqueue_script('changePassword', get_bloginfo('stylesheet_directory') . '/js/app/changePassword.js', array(), '1.0.7', true );
    }
	if ( is_page( 'CreateUser') ) {
		wp_enqueue_script('createuser', get_bloginfo('stylesheet_directory') . '/js/app/createuser.js', array(), '1.0.7', true );
		wp_enqueue_script('changePassword', get_bloginfo('stylesheet_directory') . '/js/app/changePassword.js', array(), '1.0.7', true );
    }
}

/* Load Stylesheets
***************************************************************************/

// Call external css in header; safe and recommended method (http://codex.wordpress.org/Function_Reference/wp_enqueue_style)
function my_styles_method() {
  // Register the style like this for a theme:
  // (First the unique name for the style (custom-style) then the src,
  // then dependencies and ver no. and media type)
  wp_register_style( 'foundation', get_bloginfo('stylesheet_directory') . '/css/foundation.min.css', array(), 'all' );
  wp_register_style( 'app', get_bloginfo('stylesheet_directory') . '/css/app.css', array(), 'all' );
  wp_register_style( 'search_page', get_bloginfo('stylesheet_directory') . '/css/search_page.css', array(), 'all' );
  wp_register_style( 'search_table', get_bloginfo('stylesheet_directory') . '/css/search_table.css', array(), 'all' );
  wp_register_style( 'header', get_bloginfo('stylesheet_directory') . '/css/header.css', array(), 'all' );
  wp_register_style( 'jquery-ui', get_bloginfo('stylesheet_directory') . '/css/jui/jquery-ui.css', array(), 'all' );

  // enqueing:
  wp_enqueue_style( 'foundation' );
  wp_enqueue_style( 'app' );

  /* Page Level Styles ***************************************************************************/
  if ( is_page( '9') ) {
         wp_enqueue_style( 'jquery-ui' );
         wp_enqueue_style( 'search_table' );
  }
  if ( is_page( '10') ) {
          wp_enqueue_style( 'jquery-ui' );
  }
  if ( is_page( 'SearchUser') ) {
  		wp_enqueue_style( 'search_table' );
  }

}

	add_action('wp_enqueue_scripts', 'my_scripts_method'); // Call JavaScript Files
	add_action('wp_enqueue_scripts', 'my_styles_method'); // Call Stylesheets


//End
?>