var bfoOperation="";

function BfoClass() {};
BfoClass.prototype.bfoValidationReq = function() {
		var modalreq = { "version":"1",
		"lang":"en_US",
		"trackingNumber":"",
		"updateCriteria" : [
			 { "masterAttributeId" : "",
				"masterAttributeName" : "", // Override ECPD Id
				"attributeValue" : ""
			  },
			  { "masterAttributeId" : "",
				"masterAttributeName" : "", //Valid Reason
				"attributeValue" : ""
			  },
			  { "masterAttributeId" : "",
				"masterAttributeName" : "", //User Name
				"attributeValue" : ""
			  },
			  { "masterAttributeId" : "",
			  	"masterAttributeName" : "", //Disable API
			  	"attributeValue" : ""
			  }
			],
		"submissionAction":"", //VZW_BFO_VALIDATE
		"stateProcessItemContext":"CUSTOMER_SERVICE", //CUSTOMER_SERVICE
		"applicationArea":"WEB", //WEB
		"comments":"" //Invalidated on bfo care site
	};

	return modalreq;

}

function handleBfoValidationRespOnError( jqXHR, errorType, exception ) {
	var message = MESSAGES.ERROR.TECHNICAL_ERROR;

	try{
		if(jqXHR.responseText !== 'undefined' && jqXHR.responseText != null)
		{
			var data = JSON.parse(jqXHR.responseText);
			if(hasUserAuthenticated(jqXHR, false) == false  ) {
				message = appendBFOErrorDetails(MESSAGES.STATUS.USER_SESSION_EXPIRED);
			} else if(hasUserAuthorized(jqXHR) == false && data.errorDetails != "Could_not_acquire_lock"  ) {
				message = appendBFOErrorDetails(MESSAGES.STATUS.RESOURCE_ACCESS_DENIED);
			} else if(hasUserAuthorized(jqXHR) == false && data.errorDetails == "Could_not_acquire_lock"  ) {
				message = appendBFOErrorDetails(MESSAGES.ERROR.SUBMISSION_LOCK_DENIED);
			} else if(data.status != null && data.status == 'ERROR') {
 				var errdetails = data.errorCode + "<br />Details: " + data.errorDetails;
				message = appendBFOErrorDetails(errdetails);
			}
		}
	} catch(e) {
		message =MESSAGES.ERROR.TECHNICAL_ERROR;
	}

	jQuery( "#validateInvalidateAjaxRespSection" ).show();
	jQuery( "#validateInvalidateAjaxResp" ).html(message);
}

function appendBFOErrorDetails(errdetails ) {
    var message;
	if(bfoOperation == "VZW_BFO_VALIDATE"  ) {
		message = "Could not validate submission.<br />Error: " + errdetails ;
	} else if (bfoOperation == "VZW_BFO_INVALIDATE") {
		message = "Could not invalidate submission.<br />Error: " + errdetails ;
	} else if (bfoOperation == "SAVE_BFO_NOTES") {
		message = "Could not save bfo notes.<br />Error: " + errdetails ;
	} else {
		message = "Could not complete requested operation.<br />Error: " ;
	}

  return message;
}

function handleBfoValidationRespOnSuccess( data, statusCode, xhr ) {
	if(bfoOperation == "VZW_BFO_VALIDATE"  ) {
		window.location  = 'ViewSubmission?bfoop=' + bfoOperation + '&vzwTrackingNo='+ GetURLParameter('vzwTrackingNo') + '&rand=' +  Math.random();
	} else if (bfoOperation == "VZW_BFO_INVALIDATE") {
		window.location  = 'ViewSubmission?bfoop=' + bfoOperation + '&vzwTrackingNo='+ GetURLParameter('vzwTrackingNo') + '&rand=' +  Math.random();
	} else if (bfoOperation == "SAVE_BFO_NOTES") {

		jQuery('#frmBFOSaveNotes').each(function(){
			this.reset();  //Clear BFO Notes form fields upon success
		});

		jQuery( "#validateInvalidateAjaxRespSection" ).show();
		bfoValidationMsg = "Successfully saved bfo notes.";
 		jQuery( "#validateInvalidateAjaxResp" ).html(bfoValidationMsg);
	} else {
		jQuery( "#validateInvalidateAjaxResp" ).html("Technical error occured.");
	}

}

BfoClass.prototype.bfoAjaxRequest = function() {
	var ajaxReqModal=  {	type: 'POST',
		url: URLS.BFO_VALIDATE_SUBMISSION_REST_SERVICE_URL,
		data: '{}', /*Dummy Data */
		datType: 'json',
		async : true,
		//crossDomain: true,
		cache : false,
		contentType: SETTINGS.CONTENT_TYPE,
		complete : function(){
			jQuery.unblockUI();
		},
		//timeout: 10000,
		error: handleBfoValidationRespOnError,
		success: handleBfoValidationRespOnSuccess
	};

	return ajaxReqModal;

}


function processBFOValidation() {
	bfoOperation="VZW_BFO_VALIDATE";
	var objectBFO = new BfoClass();

  	var bfoFormvalidator = jQuery("#frmBFOValidation").validate({
		onfocusout:false,
		onkeyup:false,
		rules: {
			txtNewECPDProfileId: {
				required:true,
				validEcpdId: true
			},
			txtBfoValidationNotes: {
				required:false,
				maxlength: 100
			}
		},
		errorElement: "label" ,
		errorPlacement: function(error, element) {
				error.insertAfter(element);
		},
		messages: {
			txtNewECPDProfileId: {
				required: MESSAGES.ERROR.ECPD_ID_REQUIRED,
				validEcpdId: MESSAGES.ERROR.ECPD_ID_INVALID
			},
			txtBfoValidationNotes: {
				maxlength: MESSAGES.ERROR.BFO_NOTES_EXCEEDED_LENGTH
			}
		}
	});

	//Trim BFO notes
	var usercomments = jQuery('#txtBfoValidationNotes').val();
	jQuery('#txtBfoValidationNotes').val(jQuery.trim(usercomments));

	if(bfoFormvalidator.form()) {

		var r=confirm("Do you wish to continue with BFO validation?");
		if (r == false) {
			return false;
		}
		var bforeqModal = objectBFO.bfoValidationReq();
		bforeqModal.trackingNumber=jQuery('#trackingNumber').val();
		  bforeqModal.updateCriteria[0].masterAttributeName="Override ECPD Id";
		  bforeqModal.updateCriteria[0].attributeValue=jQuery('#txtNewECPDProfileId').val();

		  bforeqModal.updateCriteria[1].masterAttributeName="Valid Reason";
		  bforeqModal.updateCriteria[1].attributeValue=jQuery('#selectValidreasons').val();

		  bforeqModal.updateCriteria[2].masterAttributeName="BFO User Name";
		  bforeqModal.updateCriteria[2].attributeValue= getuserName();

		  bforeqModal.updateCriteria[3].masterAttributeName="Disable API";
		  bforeqModal.updateCriteria[3].attributeValue=jQuery('#chkDisableAPI').is(':checked') ? true : false;


		  bforeqModal.submissionAction="VZW_BFO_VALIDATE";
		  bforeqModal.comments=getuserName() + ":VZW_BFO_VALIDATE:" + "Ecpd id -" + jQuery('#txtNewECPDProfileId').val() +
							   ":Valid Reason - " + jQuery('#selectValidreasons').val() +
							   ":Comments - " + jQuery('#txtBfoValidationNotes').val();

		  var ajaxReq= objectBFO.bfoAjaxRequest();
		  ajaxReq.data=JSON.stringify(bforeqModal);
		  var AjaxResult = jQuery.ajax(ajaxReq);

	} else {
       return false;
	}



}

function processBFOInvalidation() {
	bfoOperation="VZW_BFO_INVALIDATE";
	var objectBFO = new BfoClass();

	var bfoFormvalidator = jQuery("#frmBFOInvalidation").validate({
		onfocusout:false,
		onkeyup:false,
		rules: {
			txtBfoInvalidationNotes: {
				required:false,
				maxlength: 100
			}
		},
		messages: {
			txtBfoInvalidationNotes: {
				maxlength: MESSAGES.ERROR.BFO_NOTES_EXCEEDED_LENGTH
			}
		}
	});

    //Trim BFO notes
	var usercomments = jQuery('#txtBfoInvalidationNotes').val();
	jQuery('#txtBfoInvalidationNotes').val(jQuery.trim(usercomments));

	if(bfoFormvalidator.form()) {
		var r=confirm("Do you wish to continue with BFO invalidation?");
		if (r == false) {
			return false;
		}
		var bforeqModal = objectBFO.bfoValidationReq();
		bforeqModal.trackingNumber=jQuery('#trackingNumber').val();


		bforeqModal.updateCriteria[0].masterAttributeName="Valid Reason";
		bforeqModal.updateCriteria[0].attributeValue=jQuery('#selectInvalidreasons').val();
		bforeqModal.updateCriteria[1].masterAttributeName="BFO User Name";
		bforeqModal.updateCriteria[1].attributeValue= getuserName();

		bforeqModal.updateCriteria.splice(2,2);
		bforeqModal.submissionAction="VZW_BFO_INVALIDATE";
		bforeqModal.comments=getuserName() + ":VZW_BFO_INVALIDATE" +
						   ":Invalid Reason - " + jQuery('#selectInvalidreasons').val() +
						   ":Comments - " + jQuery('#txtBfoInvalidationNotes').val();


		var ajaxReq= objectBFO.bfoAjaxRequest();
		ajaxReq.data=JSON.stringify(bforeqModal);
		var AjaxResult = jQuery.ajax(ajaxReq);
  	} else {
       return false;
	}

}

function processSaveBFONotes() {
	bfoOperation="SAVE_BFO_NOTES";
	var objectBFO = new BfoClass();

	var bfoFormvalidator = jQuery("#frmBFOSaveNotes").validate({
		onfocusout:false,
		onkeyup:false,
		rules: {
			txtBfoNotes: {
				required:true,
				maxlength: 250
			}
		},
		messages: {
			txtBfoNotes: {
				required: MESSAGES.ERROR.BFO_NOTES_REQUIRED,
				maxlength: MESSAGES.ERROR.BFO_NOTES_EXCEEDED_LENGTH
			}
		}
	});

    //Trim BFO notes
	var usercomments = jQuery('#txtBfoNotes').val();
	jQuery('#txtBfoNotes').val(jQuery.trim(usercomments));

	if(bfoFormvalidator.form()) {
		var r=confirm("Do you wish to continue with saving BFO notes?");
		if (r == false) {
		return false;
		}
		var bforeqModal = objectBFO.bfoValidationReq();
		bforeqModal.trackingNumber=jQuery('#trackingNumber').val();

		bforeqModal.updateCriteria[0].masterAttributeName="BFO User Name";
		bforeqModal.updateCriteria[0].attributeValue= getuserName();
		bforeqModal.updateCriteria.splice(1,3);
		bforeqModal.submissionAction="";
		bforeqModal.comments=getuserName() +
						   ":Comments - " + jQuery('#txtBfoNotes').val();

		var ajaxReq= objectBFO.bfoAjaxRequest();
		ajaxReq.data=JSON.stringify(bforeqModal);
		var AjaxResult = jQuery.ajax(ajaxReq);
  	} else {
       return false;
	}
}

