function getSuccessMessage(msg){
	return "<label class='success'>" + msg + "</label><br><a class='button' href='javascript:$.unblockUI();' id='changepasswordmessage_close'>Close</a>";
}

function getErrorMessage(msg){
	return "<label class='error'>" + msg + "</label><br><a class='button' href='javascript:$.unblockUI();' id='changepasswordmessage_close'>Close</a>";
}

function showResetPasswordRespOnSuccess( data, statusCode, xhr ) {
	//Triggered after a successful response from server
	if(data.status == "SUCCESS" || data.status == "SUCESS" ) {
		$.blockUI({ message: getSuccessMessage(MESSAGES.SUCCESS.RESET_PASSWORD_EMAIL_SENT), css: { width: '275px' } });
		return true;
	}
}

function handleResetPasswordRespOnError( jqXHR, errorType, exception ) {

    var message =MESSAGES.ERROR.TECHNICAL_ERROR;
	try{
	
		if(jqXHR.responseText !== 'undefined' && jqXHR.responseText != null)
		{
			var data = JSON.parse(jqXHR.responseText);
			if (typeof (console) != 'undefined' && console != null) {
				console.log("Error");
				console.log(data.status);
			}
			if(data.status != null && data.status == 'ERROR')
			{         	
				if(data.errorCode ==='CS_RESOURCE_NOT_FOUND')
				{
					message=MESSAGES.ERROR.USER_NOT_FOUND_ERROR;
				}
				else if(data.errorCode ==='CS_INVALID_CREDENTIALS')
				{
					message=MESSAGES.ERROR.INVALID_CREDENTIALS_ERROR;
				}
				else if(data.errorCode ==='CS_NO_EMAIL_ON_FILE')
				{
					message=MESSAGES.ERROR.NO_EMAIL_ON_FILE;
				}
				else if(data.errorCode ==='CS_USER_INACTIVE')
				{
					message=MESSAGES.ERROR.USER_INACTIVE_ERROR;
				}
				else if(data.errorCode ==='VALIDATION_ERROR')
				{
					message+=MESSAGES.ERROR.VALIDATION_ERROR;
					var str = data.errorDetails.split(",");
					var i=0;
					message+="<ul>";
					for(i = 0; i < str.length; i++){
						message+="<li>" + str[i].replace(":invalid","") + "</li>";
					}
					message+="</ul>";
				}
			}
		}
	} catch(e) {
		console.log("Exception occured");
	}
	$.blockUI({ message: getErrorMessage(message), css: { width: '275px' } });
	return true;
}

jQuery(document).ready(function() {

	jQuery('#linkChangePassword').click(function() {
		var ajaxRequest = {
			type: 'GET',
			url: URLS.AUTH_SEND_PASSWORD_RESET_EMAIL_URL + "/" + SETTINGS.DEFAULT_VERSION + "/" + SETTINGS.DEFAULT_LANG + "/" + getuserName(), 
			async : true,
			cache : false,
			beforeSend: function() {
				jQuery.blockUI({message: MESSAGES.STATUS.AJAX_LOADING});     
			},
			complete : function(){
			},
			error: handleResetPasswordRespOnError,
			success: showResetPasswordRespOnSuccess
		};
		var AjaxResult = jQuery.ajax(ajaxRequest);
		return false;
	}); //jQuery('#linkChangePassword').click
}); //jQuery(document).ready