
jQuery.validator.addMethod("regex",function(value, element, regexp) {
    return this.optional(element) || regexp.test(value);
},"Please check your input." );

jQuery(document).ready(function() {
	jQuery('#firstName').focus();
	jQuery('#contactus_submit').click(function() {
		createContactUsValidator();
		sendContactUsInfo();	
	});

	jQuery('#phone').inputmask(VALIDATIONS.MASK.PHONE_NUMBER_MASK,{clearIncomplete:true,autoUnmask:true});
});

function submitUrl(name) {
	
	window.location=name;
}

function ContactusRequest ()
{
    this.version=1;
    this.lang="en_US";
    this.firstName="";
    this.lastName="";
    this.emailAddress="";
    this.trackingNumber="";
    this.comments="";
    this.questionRegardingOffer="";
    this.promotionNumber="";
    this.zip="";
    this.phone="";
    this.whatHelpNeeded="";
    this.module="Vzw Employment Validation";
}

var sendContactUsInfo = function() {

       jQuery('#contactus_error_message').hide();
       jQuery('#contactus_confirmationblock').hide();

	var validForm = jQuery('#contactus_inputform').valid();
	if( jQuery('input:radio[name=contactreason]:checked').val() == undefined ) {
		validForm = false;
		jQuery("#contactreason_required").empty().append(MESSAGES.ERROR.COMMENTS_REQ_MSG);
	} else {
		jQuery("#contactreason_required").empty();
	}
	
	if(validForm) {
		jQuery('#contactus_formblock').hide();
		sendContactInfoAjax();
	}
}

var displayContactusConfirmationblock = function() {
       jQuery('#contactus_formblock').hide();
	jQuery('#contactus_confirmationblock').show();
}

var sendContactInfoAjax = function()
{

    var result = false;
  	
    var json=createContactData();

             jQuery.ajax({
                 url : URLS.Track_REST_SERVICE_CONTACT_US_URL,
                 data : json,
                 async : true,
                 cache : false,
                 contentType:'application/json;charset=UTF-8',
                 dataType :"json",
                 type : 'POST',
                 beforeSend : function() {
                     if (typeof (console) != 'undefined' && console != null) {
                        console.log("Request: " + json);
                     }
		       jQuery.blockUI({message: "<img src='images/loading.gif' />"});
                 },
                 success : function(data) {
                     if (typeof (console) != 'undefined' && console != null) {
                         console.log("CONTACT RESPONSE JSON: " + JSON.stringify(data));
                     }
					 
                     if(data.status =='SUCCESS')
                     {
			   displayContactusConfirmationblock();	
                        result=true;
                     } else  if(data.status == 'ERROR') {
					 
				  jQuery('#contactus_confirmationblock').show();
				  jQuery('#contactus_formblock').hide();
         	                jQuery('#contactus_confirmationblock > div > p').empty().append("<br />We cannot process your request at this time. Please try again later.");
							
         	           }
                 },
                 error : function(jqXHR, textStatus, errorThrown) {
				 
                 	if(jqXHR.responseText !== 'undefined' && jqXHR.responseText != null)
                 	{
         	        	var data = JSON.parse(jqXHR.responseText);
         	            if (typeof (console) != 'undefined' && console != null) {
         	                console.log("Error");
         	                console.log(data.status);
         	            }
         	            if(data.status != null && data.status == 'ERROR')
         	            {         	
         	                var errorStr="";
         	                if(data.errorCode ==='TECHNICAL_ERROR')
         	                {
         	                    errorStr+=MESSAGES.ERROR.TECHNICAL_ERROR;
         	                }
         	                else if(data.errorCode ==='INVALID_REQUEST')
         	                {
         	                    errorStr+=MESSAGES.ERROR.INVALID_REQUEST_ERROR;
         	                }
         	                else if(data.errorCode ==='INVALID_IP_REQUEST')
         	                {
         	                    errorStr+=MESSAGES.ERROR.IP_ERROR;
         	                }
         	                else if(data.errorCode ==='VALIDATION_ERROR')
         	                {
         	                    errorStr+=MESSAGES.ERROR.VALIDATION_ERROR;
         	                    var str = data.errorDetails.split(",");
         	                    var i=0;
         	                    errorStr+="<ul>";
         	                    for(i = 0; i < str.length; i++){
         	                        errorStr+="<li>" + str[i].replace(":invalid","") + "</li>";
         	                    }
         	                    errorStr+="</ul>";
         	                }
				  jQuery('#contactus_confirmationblock').show();
				  jQuery('#contactus_formblock').hide();
                              jQuery('#contactus_confirmationblock > div > p').empty().append("<br />" + errorStr);
         	                result=false;
         	            }
                 	}
                     else
                     {
				  jQuery('#contactus_confirmationblock').show();
				  jQuery('#contactus_formblock').hide();
                              jQuery('#contactus_confirmationblock > div > p').empty().append("<br />"+ errorStr);
                         result=false;
                     }


                 },
				 complete:function()
				{					
					jQuery.unblockUI();
				}
             });

    return result;
}

var createContactData=function ()
{
    var contactReq = new ContactusRequest();
    contactReq.firstName=jQuery('#firstName').val();
    contactReq.lastName=jQuery('#lastName').val();
    contactReq.emailAddress=jQuery('#emailAddress').val();
    contactReq.comments=jQuery('#comments').val();
    contactReq.zip=jQuery('#shippingZip').val();
    contactReq.phone=jQuery('#phone').val();

    contactReq.whatHelpNeeded=jQuery('input:radio[name=contactreason]:checked').val();
    contactReq.promotionNumber=jQuery('#campaign').val();
    contactReq.trackingNumber=jQuery('#trackingNumber').val();
    contactReq.questionRegardingOffer=jQuery('#OfferQuestion').val();
    contactReq.lang ="en_US";	

    return JSON.stringify(contactReq);
}


var createContactUsValidator = function()
{
	jQuery('#contactus_inputform').validate({
			onfocusout : false,
			onkeyup : false,
			focusCleanup : false,
			focusInvalid : false,
			wrapper : "small",
			invalidHandler: function(form, validator) {
				var errors = validator.numberOfInvalids();
			},	
			highlight: function(element, errorClass) {
				jQuery(element).addClass("error");
				jQuery(element).focus();			
			},
			rules:{
				firstName :{
					required : true,
					regex:VALIDATIONS.REGEX.FIRST_NAME_REGEX
				},    
				lastName :{
					required : true,
					regex:VALIDATIONS.REGEX.LAST_NAME_REGEX
				},            
				shippingZip :{
					required: true,
					regex:VALIDATIONS.REGEX.ZIP_CODE_REGEX
				},
				phone :{
					required: true,
					regex:VALIDATIONS.REGEX.PHONE_NUMBER_REGEX
				},
				emailAddress :{
					required: true,
					email:true
				},
				emailAddressConf :{
					required: true,
					email:true,
					equalTo : '#emailAddress'
				},
				phone :{
					required: true,					
					regex:VALIDATIONS.REGEX.PHONE_NUMBER_REGEX
				}
			},             
			messages:{
				firstName :{
					required: MESSAGES.ERROR.FIRST_NAME_REQ_MSG,
					regex:MESSAGES.ERROR.FIRST_NAME_REGEX_MSG
				},
				lastName :{
					required: MESSAGES.ERROR.LAST_NAME_REQ_MSG,
					regex:MESSAGES.ERROR.LAST_NAME_REGEX_MSG
				},
				shippingZip :{
					required: MESSAGES.ERROR.ZIP_CODE_REQ_MSG,
					regex:MESSAGES.ERROR.ZIP_CODE_REGEX_MSG
				},
				phone :{
					required: MESSAGES.ERROR.PHONE_NUMBER_REQ_MSG,
					regex: MESSAGES.ERROR.PHONE_NUMBER_REGEX_MSG
				},
				emailAddress :{
					required: MESSAGES.ERROR.EMAIL_REQ_MSG,						
					email : MESSAGES.ERROR.EMAIL_NOT_VALID_MSG
				},
				emailAddressConf :{
					required: MESSAGES.ERROR.EMAIL_CONF_REQ_MSG,					
					email : MESSAGES.ERROR.EMAIL_NOT_VALID_MSG,
					equalTo : MESSAGES.ERROR.EMAIL_CONF_EQUALTO_MSG
				}
			}
	});
}


