function CreateUserRequest(){
  this.version=SETTINGS.DEFAULT_VERSION;
  this.lang=SETTINGS.DEFAULT_LANG;
  this.userName="";
  this.contextName="VERIZON";
  this.groupName="";
  this.userType="USER";
  this.firstName="";
  this.middleName="";
  this.lastName="";
  this.companyName="";
  this.faxNumber="";
  this.primaryPhoneNumber="";
  this.secondaryPhoneNumber="";
  this.primaryEmail="";
  this.secondaryEmail="";
  this.addressType="BUSINESS";
  this.streetAddress1="";
  this.streetAddress2="";
  this.streetAddress3="";
  this.streetAddress4="";
  this.city="";
  this.postalCode="";
  this.state="";
  this.country="";
  this.authToken="";
  this.createdBy="";
}

var validatorCreateUserForm = jQuery("#createUserForm").validate({
    onfocusout:false,
    onkeyup:false,
	rules: {
		email: {
			required: true,
			validEmail: true
		},
		firstName: {
			required: true
		},
		lastName: {
			required: true
		},

		address1: {
			required: true
		},
		city: {
			required: true
		},
		state: {
			required: true
		},
		zip: {
			required: true
		},
		userName: {
			required: true,
			validUserName: true
		},
		group: {
			required: true
		}
	},
	errorElement: "label" ,
	errorPlacement: function(error, element) {
		error.insertAfter(element);
	},
	messages: {
		email: {
			required: MESSAGES.ERROR.ERROR_EMAIL_REQ_MSG,
			validEmail: MESSAGES.ERROR.ERROR_EMAIL_NOT_VZW
		},
		firstName: {
			required: MESSAGES.ERROR.ERROR_FIRST_NAME_REQ_MSG
		},
		lastName: {
			required: MESSAGES.ERROR.ERROR_LAST_NAME_REQ_MSG
		},
		address1: {
			required: MESSAGES.ERROR.ERROR_ADDRESS_REQ_MSG
		},
		city: {
			required: MESSAGES.ERROR.ERROR_CITY_REQ_MSG
		},
		state: {
			required: MESSAGES.ERROR.ERROR_STATE_REQ_MSG
		},
		zip: {
			required: MESSAGES.ERROR.ERROR_ZIP_REQ_MSG
		},
		userName: {
			required: MESSAGES.ERROR.USERNAME_REQUIRED,
			validUserName: MESSAGES.ERROR.USERNAME_INVALID
		},
		group: {
			required: MESSAGES.ERROR.ERROR_AUTH_GROUP_REQ_MSG
		}
	}
});

function loadUserDetails() {
	jQuery('#emailConfirm').html(getNonNullValue(jQuery('#email').val()));
	jQuery('#firstNameConfirm').html(getNonNullValue(jQuery('#firstName').val()));
	jQuery('#lastNameConfirm').html(getNonNullValue(jQuery('#lastName').val()));
	jQuery('#address1Confirm').html(getNonNullValue(jQuery('#address1').val()));
	jQuery('#address2Confirm').html(getNonNullValue(jQuery('#address2').val()));
	jQuery('#cityConfirm').html(getNonNullValue(jQuery('#city').val()));
	jQuery('#stateConfirm').html(getNonNullValue(jQuery('#state option:selected').text()));
	jQuery('#zipConfirm').html(getNonNullValue(jQuery('#zip').val()));
	jQuery('#userNameConfirm').html(getNonNullValue(jQuery('#userName').val()));
	jQuery('#groupConfirm').html(getNonNullValue(jQuery('#group').val()));
}

function handleRespOnSaveSuccess( data, statusCode, xhr ) {
	if(data.status == "SUCCESS" || data.status == "SUCESS" ) {
		showSuccessMessage(data.userName);
	}
}

function showErrorMsg(message) {
	jQuery('#userErrorPanel').show();
	jQuery('#userErrorMsg').html(message);
}

function handleRespOnError( jqXHR, errorType, exception ) {

	var message = MESSAGES.ERROR.TECHNICAL_ERROR;
	if(hasUserAuthenticated(jqXHR, false) == false  ) {
		message = MESSAGES.STATUS.USER_SESSION_EXPIRED;
	} else if(hasUserAuthorized(jqXHR) == false  ) {
		message = MESSAGES.STATUS.RESOURCE_ACCESS_DENIED;
	}
	try{
		if(jqXHR.responseText !== 'undefined' && jqXHR.responseText != null)
		{
			var data = JSON.parse(jqXHR.responseText);
			if (typeof (console) != 'undefined' && console != null) {
				console.log("Error");
				console.log(data.status);
				console.log(data.errorCode);
			}
			if(data.status != null && data.status == 'ERROR')
			{
				if(data.errorCode ==='VZ_AS_USER_CONFLICT')
				{
					message=MESSAGES.ERROR.USER_ALREADY_EXISTS;
				}
				else if(data.errorCode ==='VZ_AS_REQUEST_VALIDATION_EXCEPTION')
				{
					message+=MESSAGES.ERROR.VALIDATION_ERROR;
					var str = data.errorDetails.split(",");
					var i=0;
					message+="<ul>";
					for(i = 0; i < str.length; i++){
						message+="<li>" + str[i].replace(":invalid","") + "</li>";
					}
					message+="</ul>";
				}
			}
		}
	} catch(e) {
		console.log("Exception occured");
	}
	showErrorMsg(message);
}

function showSuccessMessage(userName){
	jQuery('#userErrorPanel').hide();
	jQuery('#create').hide();
	jQuery('#confirm').hide();
	jQuery('#userSuccessPanel').show();
	jQuery('#userSuccessMsg').html("User <a href='page-displayuser.php?userName="+userName+"'>" + userName + "</a> has been created");
}

function confirmUser(){
	loadUserDetails();
	jQuery('#create').hide();
	jQuery('#confirm').show();
}

function editUser(){
	jQuery('#create').show();
	jQuery('#confirm').hide();
}

jQuery(document).ready(function() {
	checkUserSession(true);
	welcomeUser();
	displayAdminNav();
	jQuery('#createUserLink').addClass('active');
	jQuery('#searchUserLink').removeClass('active');

	jQuery('#create').show();
	jQuery('#confirm').hide();
	jQuery('#userSuccessPanel').hide();
	jQuery('#userErrorPanel').hide();

	jQuery.validator.addMethod("validUserName", function(value, element) {
    	return this.optional(element) || VALIDATIONS.REGEX.USERNAME_REGEX.test(value);
    }, MESSAGES.ERROR.USERNAME_INVALID);

	jQuery.validator.addMethod("validEmail", function(value, element) {
    	return VALIDATIONS.REGEX.VZW_EMAIL.test(value);
    }, MESSAGES.ERROR.ERROR_EMAIL_NOT_VZW);



	jQuery('#createButton').click(function() {
			checkUserSession(true);
			if(validatorCreateUserForm.form()) {
				confirmUser();
			}
		});
	jQuery('#editButton').click(function() {
			checkUserSession(true);
			editUser();
		});

	jQuery('#saveButton').click(function() {
		checkUserSession(true);
		jQuery('#email').val(jQuery.trim(jQuery('#email').val()));
		jQuery('#firstName').val(jQuery.trim(jQuery('#firstName').val()));
		jQuery('#lastName').val(jQuery.trim(jQuery('#lastName').val()));
		jQuery('#address1').val(jQuery.trim(jQuery('#address1').val()));
		jQuery('#address2').val(jQuery.trim(jQuery('#address2').val()));
		jQuery('#city').val(jQuery.trim(jQuery('#city').val()));
		jQuery('#zip').val(jQuery.trim(jQuery('#zip').val()));
		jQuery('#userName').val(jQuery.trim(jQuery('#userName').val()));

		var ajaxRequest = {
			type: 'POST',
			url: URLS.CERATE_USER_REST_SERVICE_URL,
			data: '{}', 
			dataType: 'json',
			async : true,
			cache : false,
			contentType: SETTINGS.CONTENT_TYPE,
			beforeSend: function() {
				jQuery.blockUI({message: MESSAGES.STATUS.AJAX_LOADING});
	        },
	        complete : function(){
				jQuery.unblockUI();
	        },
			error: handleRespOnError,
			success: handleRespOnSaveSuccess
		};


		createUserRequest= new CreateUserRequest();

		if(jQuery('#email').val()!=""){
			createUserRequest.primaryEmail =jQuery('#email').val();
		}
		if(jQuery('#firstName').val()!=""){
			createUserRequest.firstName =jQuery('#firstName').val();
		}
		if(jQuery('#lastName').val()!=""){
			createUserRequest.lastName =jQuery('#lastName').val();
		}
		if(jQuery('#address1').val()!=""){
			createUserRequest.streetAddress1 =jQuery('#address1').val();
		}
		if(jQuery('#address2').val()!=""){
			createUserRequest.streetAddress2 =jQuery('#address2').val();
		}
		if(jQuery('#city').val()!=""){
			createUserRequest.city =jQuery('#city').val();
		}
		if(jQuery('#state').val()!=""){
			createUserRequest.state =jQuery('#state').val();
		}
		if(jQuery('#zip').val()!=""){
			createUserRequest.postalCode =jQuery('#zip').val();
		}
		if(jQuery('#userName').val()!=""){
			createUserRequest.userName=jQuery('#userName').val();
		}
		if(jQuery('#group').val()!=""){
			createUserRequest.groupName=jQuery('#group').val();
		}

		createUserRequest.authToken=getUserAuthToken();
		createUserRequest.createdBy=getuserName();

		//Set Ajax Request Data
		ajaxRequest.data=JSON.stringify(createUserRequest);
		var AjaxResult = jQuery.ajax(ajaxRequest);
		return false;
	}); 

});