function UserAuthRequest () {
	this.version="";
	this.lang="";
	this.userName="";
	this.password="";
	this.contextName="";
}

var validatoruserloginForm = jQuery("#formuserlogin").validate({
    onfocusout:false,
    onkeyup:false,
	ignore: ".ignore",
	rules: {
		username: {
			required:true,
			validUserName: true
		},
		password: {
			required: true,
			validPassword: true
		}
	},
	errorElement: "label" ,
	errorPlacement: function(error, element) {
			error.insertAfter(element);
	},
	messages: {
		username: {
			required: MESSAGES.ERROR.USERNAME_REQUIRED,
			validUserName: MESSAGES.ERROR.USERNAME_INVALID
		},
		password: {
			required: MESSAGES.ERROR.PASSWORD_REQUIRED,
			validPassword: MESSAGES.ERROR.PASSWORD_INVALID
		}
	}
});

function showUserAuthRespOnSuccess( data, statusCode, xhr ) {
	//Triggered after a successful response from server
	if(data.status == "SUCCESS" || data.status == "SUCESS" ) {
		createSession(data);
		 
		if(isUserhasRole('appcsr') || isUserhasRole('webuser')){
		 
			window.location = "page-searchsubmissions.php";
		}
		else if(isUserhasRole('createuser') || isUserhasRole('updateuser')){
			 
			window.location = "page-searchuser.php";
		}
		else{
			jQuery('#LoginPanelMsg').html("Not enough roles");
			jQuery('#LoginPanelMsg').parent().show();
		}
		return true;
	}

}

function handleLoginActions() {
	var action = GetURLParameter('action');
	if(action != null && action == 'sessionexpired') {
		jQuery('#LoginPanelMsg').html(MESSAGES.STATUS.USER_SESSION_EXPIRED);
		jQuery('#LoginPanelMsg').parent().show();
	} else if(action != null && action == 'invalidsession') {
		jQuery('#LoginPanelMsg').html(MESSAGES.STATUS.USER_SESSION_INVALID);
		jQuery('#LoginPanelMsg').parent().show();
	} else if(action != null && action == 'logout') {
		jQuery('#LoginPanelMsg').html(MESSAGES.STATUS.USER_LOGOUT);
		jQuery('#LoginPanelMsg').parent().show();
	} else {
		jQuery('#LoginPanelMsg').parent().hide();
	}
}


function handleUserAuthRespOnError( jqXHR, errorType, exception ) {

    var message =MESSAGES.ERROR.TECHNICAL_ERROR;
	try{

		if(jqXHR.responseText !== 'undefined' && jqXHR.responseText != null)
		{
			var data = JSON.parse(jqXHR.responseText);
			if (typeof (console) != 'undefined' && console != null) {
				console.log("Error");
				console.log(data.status);
				console.log(data.errorCode);
			}
			if(data.status != null && data.status == 'ERROR')
			{
				if(data.errorCode ==='CS_RESOURCE_NOT_FOUND')
				{
					message=MESSAGES.ERROR.USER_NOT_FOUND_ERROR;
				}
				else if(data.errorCode ==='CS_INVALID_CREDENTIALS')
				{
					message=MESSAGES.ERROR.INVALID_CREDENTIALS_ERROR;
				}
				else if(data.errorCode ==='CS_PASSWORD_EXPIRED')
				{
					alert(MESSAGES.ERROR.PASSWORD_EXPIRED_ALERT);
					window.location = "resetpassword/?username=" + data.userName + "&token=" + data.resetPasswordToken +"&rand=" + Math.random();
					message=MESSAGES.ERROR.PASSWORD_EXPIRED_ERROR;
				}
				else if(data.errorCode ==='CS_USER_INACTIVE')
				{
					message=MESSAGES.ERROR.USER_INACTIVE_ERROR;
				}
				else if(data.errorCode ==='CS_USER_LOCKED')
				{
					message=MESSAGES.ERROR.USER_LOCKED;
				}
				else if(data.errorCode ==='CS_LOGIN_ATTEMPTS_EXCEEDED')
				{
					message=MESSAGES.ERROR.LOGIN_ATTEMPTS_EXCEEDED;
				}
				else if(data.errorCode ==='VALIDATION_ERROR')
				{
					message+=MESSAGES.ERROR.VALIDATION_ERROR;
					var str = data.errorDetails.split(",");
					var i=0;
					message+="<ul>";
					for(i = 0; i < str.length; i++){
						message+="<li>" + str[i].replace(":invalid","") + "</li>";
					}
					message+="</ul>";
				}
			}
		}
	} catch(e) {
		console.log("Exception occured");
	}

	jQuery('#userAuthResponse').show();
	jQuery('#userAuthResponse').html(message);
	return true;
}

jQuery(document).ready(function() {

	if(isUserLoginSessionActive() ) {
		gotoHomePage();
		return;
	} else {
		clearSession();
	}
	jQuery.validator.addMethod("regex",function(value, element, regexp) {
           return this.optional(element) || regexp.test(value);
    },"Please check your input." );


    jQuery.validator.addMethod("validUserName", function(value, element) {
    	return this.optional(element) || VALIDATIONS.REGEX.USERNAME_REGEX.test(value);
    }, MESSAGES.ERROR.USERNAME_INVALID);

    jQuery.validator.addMethod("validPassword", function(value, element) {
    	return this.optional(element) || VALIDATIONS.REGEX.PASSWORD_REGEX.test(value);
    }, MESSAGES.ERROR.PASSWORD_INVALID);
	handleLoginActions();
	jQuery('#btnlogin').click(function() {
		jQuery('#LoginPanelMsg').parent().hide();
	    jQuery('#username').val(jQuery.trim(jQuery('#username').val()));
        jQuery('#password').val(jQuery.trim(jQuery('#password').val()));

		var ajaxRequest = {
			type: 'POST',
			url: URLS.AUTHENTICATE_USER_REST_SERVICE_URL,
			data: '{}',
			datType: 'json',
			async : true,
			beforeSend: function(xhr) {
				jQuery.blockUI({message: MESSAGES.STATUS.AJAX_LOADING});
			},
			cache : false,
			contentType: SETTINGS.CONTENT_TYPE,
	        complete : function(){
				jQuery.unblockUI();
	        },
			error: handleUserAuthRespOnError,
			success: showUserAuthRespOnSuccess
		};

		if(validatoruserloginForm.form()) {
		
			authRequest= new UserAuthRequest();
			authRequest.userName=jQuery('#username').val();
			authRequest.password =jQuery('#password').val();
			authRequest.lang=SETTINGS.DEFAULT_LANG;
			authRequest.version=SETTINGS.DEFAULT_VERSION;
			authRequest.contextName="VERIZON";

			//Set Ajax Request Data
			ajaxRequest.data=JSON.stringify(authRequest);
			var AjaxResult = jQuery.ajax(ajaxRequest);
		} else {
		
			return false;
		}

		//Reset password filed.
		jQuery('#password').val('');
			return false;
	}); 
}); 