MESSAGES ={
	ERROR: {
		USERNAME_REQUIRED:"User Name is required.",
		USERNAME_INVALID:"Incorrect format, Please conform to [a-zA-Z0-9._].",

		PASSWORD_REQUIRED:"Password is required.",
		CONFIRM_PASSWORD_REQUIRED:"Confirm Password is required.",
		PASSWORD_INVALID:"Password does not meet security policy. Please reset your password.",
		CONFIRM_PASSWORD_NOT_MATCH:"Password and Confirm Password must match.",

		PASSWORD_RESET_FORBIDDEN:"Your request could not be processed. The password reset token in your email may have expired.",
		PASSWORD_POLICY_VIOLATION:"Your password must be between 8 and 50 characters and must contain at least one upper and one lower case letter, one number and one special character.",

		TRACKING_NO_REQUIRED:"Tracking Number is required.",
		TRACKING_NO_INVALID:"Incorrect format, please re-enter the complete 14 character Tracking number (e.g. W1234567890123).",

		MTN_REQUIRED:"or MTN is required.",
		MTN_INVALID:"Incorrect format, please re-enter valid 10 digit mobile number.",

		ECPD_ID_REQUIRED:"Ecpd Id is required.",
		ECPD_ID_INVALID:"Incorrect Ecpd Id, please re-enter valid Ecpd Id.",
		BFO_NOTES_REQUIRED:"Notes are required.",
		BFO_NOTES_EXCEEDED_LENGTH:"Notes exceeded allowed character limit.",

		FROM_DATE_REQUIRED:"From Date is required.",
		TO_DATE_REQUIRED:"To Date is required.",
		FILTER_DATE_INVALID:"Date is invalid.",
		FROM_DATE_INVALID:"From Date is invalid.",
		TO_DATE_INVALID:"To Date is invalid.",
		FILTER_DATE_RANGE_INVALID:"Date range is invalid.",
		NO_EMAIL_ON_FILE:"This operation cannot be completed since there is no email on file for this user. Please contact customer service.",

		ERROR_FIRST_NAME_REQ_MSG:"First Name is required",
		ERROR_LAST_NAME_REQ_MSG:"Last Name is required",
		ERROR_ZIP_REQ_MSG:"Zip Code is required",
		ERROR_PHONE_REQ_MSG:"Phone number is required",
		ERROR_EMAIL_REQ_MSG:"Email Address is required",
		ERROR_ADDRESS_REQ_MSG:"Address is required",
		ERROR_CITY_REQ_MSG:"City is required",
		ERROR_STATE_REQ_MSG:"State is required",
		ERROR_AUTH_GROUP_REQ_MSG:"Authorization Group is required",
		ERROR_EMAIL_CONF_REQ_MSG:"Please confirm your Email Address",
		ERROR_EMAIL_CONF_EQUALTO_MSG:"Email Addresses do not match",
		ERROR_EMAIL_FORMAT_MSG:"Invalid email format",
		ERROR_EMAIL_NOT_VZW:"Invalid email. Email address must end with @verizonwireless.com or @bhengagement.com",


		EMAIL_REQ_MSG:"Email Address is required",
		EMAIL_CONF_REQ_MSG:"Please confirm your Email Address",
		EMAIL_CONF_EQUALTO_MSG:"Email Addresses do not match",
		EMAIL_NOT_VALID_MSG:"The Email Address is not valid.",

		//USER LOGIN PAGE
		INVALID_CREDENTIALS_ERROR:"The username or password you entered is incorrect.",
		USER_NOT_FOUND_ERROR:"The username or password you entered is incorrect.",
		NO_USER_FOUND:"The username entered is not associated with an active account.",
		PASSWORD_EXPIRED_ERROR:"Password expired. Please wait while we take you to change password page.",
		PASSWORD_EXPIRED_ALERT:"Password expired. You will be taken to another page where you will be able to change your password.",
		USER_LOCKED:"Your account is locked. Please contact system administrator.",
		LOGIN_ATTEMPTS_EXCEEDED:"Password retries exceeded. Please contact system administrator.",
		USER_INACTIVE_ERROR:"User account is inactive. Please contact your System Administrator.",

		//Submission Search Page
		SUBMISSION_SEARCH_NO_RECORDS_FOUND:"No records found.",
		SUBMISSION_SEARCH_NO_MATCHING_RECORDS_FOUND:"No matching records found.",
		SUBMISSION_SEARCH_DATE_RANGE_MORE_THAN_90_DAYS_OLD:"The search might take longer time to retrieve 90 or more days older records, Do you want to continue?",

		TECHNICAL_ERROR:"We cannot process your request at this time. Please try again later.",
		INVALID_REQUEST_ERROR:"We cannot process your request at this time. Please try again later.",
		VALIDATION_ERROR:"Please correct the following information:",
		STORE_ERROR:"We're sorry that store number can not be found.",
		CAMPAIGN_ERROR:"We're sorry that rebate offer number can not be found.",
		IP_ERROR:"We're sorry your ip address as reached the limit of submission allowed.  Please try again in an hour. Thank you.",
		SUBMISSION_LOCK_DENIED:"Failed to acquire lock while updating submission.",

		//Search User Page
		SEARCH_USERNAME_REQUIRED:"User Name is required.",
		FIRSTNAME_REQUIRED:"First Name is required.",
		LASTNAME_REQUIRED:"Last Name is required.",


		USER_ALREADY_EXISTS:"A user with this user name already exists. Please choose a different user name."
	},
	VALIDATION: {
		DEMOG_LASTNAME_MAXLEN:"Last Name exceeded allowed 50 character limit.",
		DEMOG_FIRSTNAME_MAXLEN:"First Name exceeded allowed 50 character limit.",
		DEMOG_ADDRESS_MAXLEN:"Address exceeded allowed 50 character limit.",
		DEMOG_ADDRESS2_MAXLEN:"Address2 exceeded allowed 50 character limit.",
		DEMOG_EMAIL_MAXLEN:"Email exceeded allowed 50 character limit.",
		DEMOG_PHONE_INVALID:"Phone number is not valid.",
		DEMOG_ZIPCODE_INVALID:"Please re-enter valid 5 digit zip code.",
		DEMOG_SEARCH_FIELDS_EMPTY:"Please provide information for at least one of the <span style='color:red'>(*)</span> noted fields.",
		DEMOG_PRIMARYFIELD_REQUIRED:"Please provide information for at least one of the <span style='color:red'>(*)</span> noted fields.",
		CAMPATTR_LASTNAME_MAXLEN:"Last Name exceeded allowed 50 character limit.",
		CAMPATTR_FIRSTNAME_MAXLEN:"First Name exceeded allowed 50 character limit.",
		CAMPATTR_COMPANY_NAME_MAXLEN:"Company Name exceeded allowed 50 character limit.",
		CAMPATTR_ECPD_ID_MAXLEN:"Ecpd Id exceeded allowed 50 character limit.",
		CAMPATTR_ECPD_ID_INVALID:"Please re-enter valid Ecpd Id.",
		CAMPATTR_SEARCH_FIELDS_EMPTY:"Minimum of one <span style='color:red'>(*)</span> noted field required; maximum of two <span style='color:red'>(*)</span> noted fields.",
		CAMPATTR_MAX_SEARCH_FIELDS_EXCEEDED:"Minimum of one <span style='color:red'>(*)</span> field required; maximum of two <span style='color:red'>(*)</span> fields to provide search results. Please update search and try again."
	},
	SUCCESS: {
		RESET_PASSWORD_EMAIL_SENT:"An email with the instructions to change your password has been sent to your email address on file.",
		PASSWORD_RESET_SUCCESS:"Your password has been changed. Click <a href='../index.php'>here</a> to login."
	},
	STATUS: {
		AJAX_LOADING:"<h4 style='color: red'>Loading ...</h4>",
		AJAX_ERROR:"We could not process your request at this time. Please try again later or click the Contact Us link above to inquire about the status of your employment validation submission.",
		USER_SESSION_EXPIRED:"Your session has expired. Please log in again.",
		RESOURCE_ACCESS_DENIED:"Access is denied. You do not have permission to perform the requested operation.",
		USER_SESSION_INVALID:"You are not logged into your account. Please login to continue.",
		USER_LOGOUT:"You are now signed out."
	}

};
