function ResetPasswordRequest () {
	this.version="";
	this.lang="";
	this.userName="";
	this.password="";
	this.contextName="";
	this.reconfirmPassword="";
	this.resetPasswordToken="";
}

var validatoruserloginForm = jQuery("#formpasswordreset").validate({
    onfocusout:false,
    onkeyup:false,
	ignore: ".ignore",
	rules: {
		username: { 
			required:true,
			validUserName: true
		},
		password: {
			required: true,
			validPassword: true
		},
		confirmpassword: {
			required: true,
			equalTo : '#password'
		}
	},
	errorElement: "label" ,
	errorPlacement: function(error, element) {
			error.insertAfter(element);
	},               
	messages: {
		username: { 
			required: MESSAGES.ERROR.USERNAME_REQUIRED,
			validUserName: MESSAGES.ERROR.USERNAME_INVALID
		},
		password: {
			required: MESSAGES.ERROR.PASSWORD_REQUIRED,
			validPassword: MESSAGES.ERROR.PASSWORD_POLICY_VIOLATION
		},
		confirmpassword: {
			required: MESSAGES.ERROR.CONFIRM_PASSWORD_REQUIRED,
			equalTo: MESSAGES.ERROR.CONFIRM_PASSWORD_NOT_MATCH,
		}
	}
});

function showUserAuthRespOnSuccess( data, statusCode, xhr ) {
	//Triggered after a successful response from server
	if(data.status == "SUCCESS" || data.status == "SUCESS" ) {
		jQuery('#resetpassword_fields').hide();
		jQuery('#resetpassword_success').show();
		jQuery('#successResponse').show();	
		jQuery('#successResponse').html(MESSAGES.SUCCESS.PASSWORD_RESET_SUCCESS);
		 
		return true;
	} 
}

function handleUserAuthRespOnError( jqXHR, errorType, exception ) {

    var message =MESSAGES.ERROR.TECHNICAL_ERROR;
	try{					
	
		if(jqXHR.responseText !== 'undefined' && jqXHR.responseText != null)
		{
			var data = JSON.parse(jqXHR.responseText);
			if (typeof (console) != 'undefined' && console != null) {
				console.log("Error");
				console.log(data.status);
				console.log(data.errorCode);
			}
			if(data.status != null && data.status == 'ERROR')
			{         	
				if(data.errorCode ==='CS_RESOURCE_NOT_FOUND')
				{
					message=MESSAGES.ERROR.USER_NOT_FOUND_ERROR;
				}
				else if(data.errorCode ==='CS_INVALID_CREDENTIALS')
				{
					message=MESSAGES.ERROR.INVALID_CREDENTIALS_ERROR;
				}
				else if(data.errorCode ==='CS_PASSWORD_EXPIRED')
				{
					message=MESSAGES.ERROR.PASSWORD_EXPIRED_ERROR;
				}
				else if(data.errorCode ==='CS_USER_INACTIVE')
				{
					message=MESSAGES.ERROR.USER_INACTIVE_ERROR;
				}
				else if(data.errorCode ==='CS_FORBIDDEN')
				{
					message=MESSAGES.ERROR.PASSWORD_RESET_FORBIDDEN;
				}
				else if(data.errorCode =='CS_REQUEST_VALIDATION_EXCEPTION')
				{
					message=MESSAGES.ERROR.VALIDATION_ERROR + "<br/>" + data.errorDetails.replace("PASSWORD:","");
				}
				else if(data.errorCode =='CS_PASSWORD_POLICY_VIOLATION')
				{
					message=MESSAGES.ERROR.PASSWORD_POLICY_VIOLATION;
				}
				else if(data.errorCode ==='VALIDATION_ERROR')
				{
					message+=MESSAGES.ERROR.VALIDATION_ERROR;
					var str = data.errorDetails.split(",");
					var i=0;
					message+="<ul>";
					for(i = 0; i < str.length; i++){
						message+="<li>" + str[i].replace(":invalid","") + "</li>";
					}
					message+="</ul>";
				}
			}
		}
	} catch(e) {
		console.log("Exception occured");
	}

	jQuery('#userAuthResponse').show();	
	jQuery('#userAuthResponse').html(message);
	return true;
}

jQuery(document).ready(function() {

	clearSession();
	jQuery.validator.addMethod("regex",function(value, element, regexp) {
           return this.optional(element) || regexp.test(value);
    },"Please check your input." );


    jQuery.validator.addMethod("validUserName", function(value, element) {
    	return this.optional(element) || VALIDATIONS.REGEX.USERNAME_REGEX.test(value);
    }, MESSAGES.ERROR.USERNAME_INVALID);
	
    jQuery.validator.addMethod("validPassword", function(value, element) {
    	return this.optional(element) || VALIDATIONS.REGEX.PASSWORD_REGEX.test(value);
    }, MESSAGES.ERROR.PASSWORD_INVALID);

 
    
	jQuery('#btnlogin').click(function() {
	    jQuery('#username').val(jQuery.trim(jQuery('#username').val()));
        jQuery('#password').val(jQuery.trim(jQuery('#password').val()));
        jQuery('#confirmpassword').val(jQuery.trim(jQuery('#confirmpassword').val()));
		
		var ajaxRequest = {
			type: 'POST',
			url: URLS.AUTH_RESET_PASSWORD_URL, 
			data: '{}', 
			datType: 'json',
			async : true, 
			cache : false,
			contentType: SETTINGS.CONTENT_TYPE,   
			beforeSend: function() {
				jQuery.blockUI({message: MESSAGES.STATUS.AJAX_LOADING});     
	        },
	        complete : function(){
				jQuery.unblockUI();
	        }, 
			error: handleUserAuthRespOnError,
			success: showUserAuthRespOnSuccess
		};
		
		if(validatoruserloginForm.form()) {
			 
			resetRequest= new ResetPasswordRequest();
			resetRequest.userName=jQuery('#username').val();
			resetRequest.password =jQuery('#password').val();
			resetRequest.lang=SETTINGS.DEFAULT_LANG;
			resetRequest.version=SETTINGS.DEFAULT_VERSION;
			resetRequest.contextName="VERIZON";
			resetRequest.reconfirmPassword=jQuery('#confirmpassword').val();
			resetRequest.resetPasswordToken=jQuery('#token').val();

			
			//Set Ajax Request Data
			ajaxRequest.data=JSON.stringify(resetRequest);
			var AjaxResult = jQuery.ajax(ajaxRequest);
		} else {
			 
			return false;
		}
		
		//Reset password filed.
		jQuery('#password').val('');
		jQuery('#confirmpassword').val('');
		return false;
	});  
}); 