function SearchUserRequest () {
	this.version="";
	this.lang="";
	this.context="VERIZON";
	this.userName="";
	this.firstName="";
	this.lastName="";
}

var validatorSeachUserForm = jQuery("#formSearchUser").validate({
    onfocusout:false,
    onkeyup:false,
	rules: {
		userName: {
			required: function(element){
				return (jQuery("#firstName").val().length <= 0 && jQuery("#lastName").val().length <= 0);
			},
			validUserName: true
		},
		firstName: {
			required: function(element){
				return jQuery("#userName").val().length <= 0 ;
			},
			validName: true
		},
		lastName: {
			required: function(element){
				return jQuery("#userName").val().length <= 0 ;
			},
			validName: true
		}
	},
	errorElement: "label" ,
	errorPlacement: function(error, element) {
			if(element.attr("name") == "userName" ) {
				error.insertAfter(element);
			} else {
				error.insertAfter(element);
			}
	},
	messages: {
		userName: {
			required: MESSAGES.ERROR.SEARCH_USERNAME_REQUIRED,
			validUserName: MESSAGES.ERROR.USERNAME_INVALID
		},
		firstName: {
			required: MESSAGES.ERROR.FIRSTNAME_REQUIRED,
			validMTN: MESSAGES.ERROR.FIRSTNAME_INVALID
		},
		lastName: {
			required: MESSAGES.ERROR.LASTNAME_REQUIRED,
			validMTN: MESSAGES.ERROR.LASTNAME_INVALID
		}

	}
});


function loadUsers(data) {

	jQuery("div#search_user").hide();
	jQuery("div#search_results").show();
	jQuery("#searchUserResults > tbody").empty();
	$('#searchUserResults').dataTable().fnClearTable();
	var t = "";
	var i=0;
	jQuery.each(data.userVO, function(i, user) {
        i= i+1;

	    if(i%2 == 0) {
		   tblClass= 'gradeX';
		} else {
			tblClass= 'gradeC';
		}

		var userEnabledStatus='Enabled';
		if(getNonNullValue(user["status"]) != 'ACTIVE') {
				userEnabledStatus ='Disabled';
		}
		if(getNonNullValue(user["locked"]) == 'YES') {
				userEnabledStatus ='Locked, '+userEnabledStatus;
		}

		var address = getNonNullValue(user.consumerDemog.addressList[0].streetAddress1) +' '+getNonNullValue(user.consumerDemog.addressList[0].city) +' '+getNonNullValue(user.consumerDemog.addressList[0].state)
						+' '+getNonNullValue(user.consumerDemog.addressList[0].postalCode);

	    t += '<tr class=">' + tblClass +'"><td>'+getNonNullValue(user["userName"]) +'</td><td><a href="page-displayuser.php?userName='+getNonNullValue(user["userName"])+'">' + user.consumerDemog.firstName +' '+ user.consumerDemog.lastName + '</a></td>'+
		'<td>' + address +'</td>' +
		'<td>' + getNonNullValue(user.consumerDemog.primaryEmail) + '</td>' +
		'<td>' + getNonNullValue(user["userType"]) + '</td> ' +
		'<td>' + userEnabledStatus + '</td>';


	});
	jQuery('#searchUserResults > tbody').append(t);
	jQuery('#searchUserResults').dataTable({
		"aaSorting" : [ [ 1, "asc" ] ],
		"bDestroy": true
 	});

}

function clearResultsPanel() {
	jQuery("#searchUserResults > tbody").empty();
	jQuery("div#search_results").hide();
	jQuery("div#search_user").show();
	removeUserResultsInStore
}

function newSearch() {
	clearResultsPanel();
	jQuery("#formSearchUser")[0].reset();
}

function clearValidationErrors() {
	jQuery(".error").html('');
	jQuery(".error").removeClass("error");
}



function showRetrieveUserRespOnSuccess( data, statusCode, xhr ) {
	//Triggered after a successful response from server
	if(data.status == "SUCCESS" || data.status == "SUCESS" ) {
		loadUsers(data);
		jQuery(window).scrollTop(0);
		saveUserResultsInStore(data);
	}
}

function handleRetrieveUserRespOnError( jqXHR, errorType, exception ) {

    var message=MESSAGES.ERROR.TECHNICAL_ERROR;
	try
	{

		if(jqXHR.responseText !== 'undefined' && jqXHR.responseText != null)
		{
			var data = JSON.parse(jqXHR.responseText);
			if (typeof (console) != 'undefined' && console != null)
			{
				console.log("Error");
				console.log(data.status);
			}

			if(jqXHR.status == 401 || jqXHR.status == 403 ) {
				alert("Session expired. Please login again.");
				window.location ="index.php";
			}
			if(data.status != null && data.status == 'ERROR')
			{
				if(data.errorCode ==='VZ_AS_RESOURCE_NOT_FOUND')
				{
					message=MESSAGES.ERROR.SUBMISSION_SEARCH_NO_RECORDS_FOUND;
					if( data.errorDetails == 'No matching records found.')
					{
						message=MESSAGES.ERROR.SUBMISSION_SEARCH_NO_MATCHING_RECORDS_FOUND;
					} else
					{
						message=MESSAGES.ERROR.SUBMISSION_SEARCH_NO_RECORDS_FOUND;
					}
				}
				else if(data.errorCode ==='VZ_AS_REQUEST_VALIDATION_EXCEPTION')
				{
					message=MESSAGES.ERROR.VALIDATION_ERROR;
					var str = data.errorDetails.split(",");
					var i=0;
					message+="<ul>";
					for(i = 0; i < str.length; i++){
						message+="<li>" + str[i].replace(":invalid","") + "</li>";
					}
					message+="</ul>";
				}
				 
			}
		}
	}
	catch(e)
	{
		console.log("Exception occured");
	}

	jQuery('#searchUserResponse').show();
	jQuery('#searchUserResponse').addClass("error");
	jQuery('#searchUserResponse').html(message);

	return true;
}


jQuery(document).ready(function() {
	checkUserSession(true);
	displayAdminNav();
	jQuery.validator.addMethod("validUserName", function(value, element) {
	    	return this.optional(element) || VALIDATIONS.REGEX.USERNAME_REGEX.test(value);
	    }, MESSAGES.ERROR.USERNAME_INVALID);

	    jQuery.validator.addMethod("validName", function(value, element) {
	    	return this.optional(element) || VALIDATIONS.REGEX.USERNAME_REGEX.test(value);
	    }, MESSAGES.ERROR.USERNAME_INVALID);


		jQuery('#userName').bind("change keypress", function() {
			if (jQuery(this).val().length > 0) {
				jQuery('#firstName').val('');
				jQuery('#lastName').val('');
				clearValidationErrors();
			}
		});

		jQuery('#firstName').bind("change keypress", function() {
			if (jQuery(this).val().length > 0) {
				jQuery('#userName').val('');
				clearValidationErrors();
			}
		});

		jQuery('#lastName').bind("change keypress", function() {
			if (jQuery(this).val().length > 0) {
				jQuery('#userName').val('');
				clearValidationErrors();
			}
		});

	welcomeUser();

	jQuery('#btnSearchUser').click(function() {
		checkUserSession(true);
        jQuery('#userName').val(jQuery.trim(jQuery('#userName').val()));
		jQuery('#firstName').val(jQuery.trim(jQuery('#firstName').val()));
		jQuery('#lastName').val(jQuery.trim(jQuery('#lastName').val()));


		var ajaxRequest = {
			type: 'POST',
			url: URLS.SEARCH_USER_REST_SERVICE_URL,
			data: '{}',  
			dataType: 'json',
			async : true, 
			cache : false,
			contentType: SETTINGS.CONTENT_TYPE,
			beforeSend: function() {
				jQuery.blockUI({message: MESSAGES.STATUS.AJAX_LOADING});
	        },
	        complete : function(){
				jQuery.unblockUI();
	        }, 
			error: handleRetrieveUserRespOnError,
			success: showRetrieveUserRespOnSuccess
		};

		if(validatorSeachUserForm.form()) { 
			var msgHeading = "Search Results for: ";
			searchUserRequest= new SearchUserRequest();
			if(jQuery('#userName').val()!=""){
				searchUserRequest.userName=jQuery('#userName').val();
				msgHeading = msgHeading + jQuery('#userName').val();
			}
			if(jQuery('#firstName').val()!=""){
				searchUserRequest.firstName =jQuery('#firstName').val();
				msgHeading = msgHeading + jQuery('#firstName').val();
			}
			if(jQuery('#lastName').val()!=""){
				searchUserRequest.lastName =jQuery('#lastName').val();
				msgHeading = msgHeading + " " + jQuery('#lastName').val();
			}

			searchUserRequest.lang=SETTINGS.DEFAULT_LANG;
			searchUserRequest.version=SETTINGS.DEFAULT_VERSION;

			//Set Ajax Request Data
			ajaxRequest.data=JSON.stringify(searchUserRequest);
			var AjaxResult = jQuery.ajax(ajaxRequest);

			jQuery('#search_results_for').html(msgHeading);
			saveMsgInStore(msgHeading);

		} else {
			 
			return false;
		}
			return false;
	});  

	jQuery('#searchUserResults').dataTable({
		"aaSorting" : [ [ 1, "asc" ] ],
		"bDestroy": true
 	});

 	if(GetURLParameter('backToResults')=='Y'){
		backToResults();
	}

}); 

function backToResults() {
	var usrResData =loadUserResultsFromStore();
	if(usrResData != null) {
		loadUsers(usrResData);
	}
	var msgHeading = loadMsgFromStore();
	jQuery('#search_results_for').html(msgHeading);
}



function saveUserResultsInStore(data) {
	try {
		if(typeof(Storage)!=="undefined") {
			sessionStorage.setItem("userSearchResultsData",JSON.stringify(data));
		}
	} catch(e) {
	}
}

function removeUserResultsInStore() {
	try {
		if(typeof(Storage)!=="undefined") {
            if(sessionStorage.getItem("userSearchResultsData") != null) {
	 			sessionStorage.removeItem('userSearchResultsData');
			}
		}
	} catch(e) {
	}
}


function loadUserResultsFromStore() {
    var data = null;
	try {
		if(typeof(Storage)!=="undefined") {
			data = JSON.parse(sessionStorage.getItem("userSearchResultsData"));
		}
	} catch(e) {
	}
	return data;
}

function saveMsgInStore(msg) {
	try {
		if(typeof(Storage)!=="undefined") {
			sessionStorage.setItem("msgHeading",msg);
		}
	} catch(e) {
	}
}

function loadMsgFromStore() {
    var data = null;
	try {
		if(typeof(Storage)!=="undefined") {
			data = sessionStorage.getItem("msgHeading");
		}
	} catch(e) {
	}
	return data;
}