var validatorResetPasswordForm = jQuery("#sendresetpasswordemailform").validate({
    onfocusout:false,
    onkeyup:false,
	rules: {
		sendresetpasswordemail_username: { 
			required:true,
			validResetPwUserName: true
		}
	},
	errorElement: "label" ,
	errorPlacement: function(error, element) {
			error.insertAfter(element);
	},               
	messages: {
		sendresetpasswordemail_username: { 
			required: MESSAGES.ERROR.USERNAME_REQUIRED,
			validUserName: MESSAGES.ERROR.USERNAME_INVALID
		}
	}
});


function showResetPasswordRespOnSuccess( data, statusCode, xhr ) {
	//Triggered after a successful response from server
	if(data.status == "SUCCESS" || data.status == "SUCESS" ) {
		jQuery.unblockUI();
		showResetPasswordEmailDialog();

		jQuery('#sendresetpasswordemail_inputs').hide();
		jQuery('#sendresetpasswordemail_messages').show();
		jQuery('#sendresetpasswordemail_successresponse').show();	
		jQuery('#sendresetpasswordemail_successresponse').html(MESSAGES.SUCCESS.RESET_PASSWORD_EMAIL_SENT);
		return true;
	}
}

function handleResetPasswordRespOnError( jqXHR, errorType, exception ) {

    var message =MESSAGES.ERROR.TECHNICAL_ERROR;
	try{
	
		if(jqXHR.responseText !== 'undefined' && jqXHR.responseText != null)
		{
			var data = JSON.parse(jqXHR.responseText);
			if (typeof (console) != 'undefined' && console != null) {
				console.log("Error");
				console.log(data.status);
			}
			if(data.status != null && data.status == 'ERROR')
			{         	
				if(data.errorCode ==='CS_RESOURCE_NOT_FOUND')
				{
					message=MESSAGES.ERROR.NO_USER_FOUND;
				}
				else if(data.errorCode ==='CS_INVALID_CREDENTIALS')
				{
					message=MESSAGES.ERROR.INVALID_CREDENTIALS_ERROR;
				}
				else if(data.errorCode ==='CS_NO_EMAIL_ON_FILE')
				{
					message=MESSAGES.ERROR.NO_EMAIL_ON_FILE;
				}
				else if(data.errorCode ==='CS_USER_INACTIVE')
				{
					message=MESSAGES.ERROR.USER_INACTIVE_ERROR;
				}
				else if(data.errorCode ==='VALIDATION_ERROR')
				{
					message+=MESSAGES.ERROR.VALIDATION_ERROR;
					var str = data.errorDetails.split(",");
					var i=0;
					message+="<ul>";
					for(i = 0; i < str.length; i++){
						message+="<li>" + str[i].replace(":invalid","") + "</li>";
					}
					message+="</ul>";
				}
			}
		}
	} catch(e) {
		console.log("Exception occured");
	}
	
	jQuery.unblockUI();
	showResetPasswordEmailDialog();

	jQuery('#sendresetpasswordemail_inputs').hide();
	jQuery('#sendresetpasswordemail_messages').show();

	jQuery('#sendresetpasswordemail_errorresponse').show();	
	jQuery('#sendresetpasswordemail_errorresponse').html(message);
	return true;
}

function showResetPasswordEmailDialog(){
	jQuery('#sendresetpasswordemail_inputs').show();
	jQuery('#sendresetpasswordemail_messages').hide();
	jQuery('#sendresetpasswordemail_successresponse').hide();	
	jQuery('#sendresetpasswordemail_errorresponse').hide();	
	jQuery('#sendresetpasswordemail_username').val("");
	jQuery('#sendresetpasswordemail_username').val(jQuery.trim(jQuery('#username').val()));
	$.blockUI({ message: $('#divresetpassword'), css: { width: '275px' } });
	return false;
}

jQuery(document).ready(function() {
 

    jQuery.validator.addMethod("validResetPwUserName", function(value, element) {
    	return this.optional(element) || VALIDATIONS.REGEX.USERNAME_REGEX.test(value);
    }, MESSAGES.ERROR.USERNAME_INVALID);
	
	jQuery('#sendresetpasswordemail_cancel').click(function() {
		$.unblockUI();
		return false;
	});

	jQuery('#sendresetpasswordemail_close').click(function() {
		$.unblockUI();
		return false;
	});
	
	 
	jQuery('#sendresetpasswordemail_ok').click(function() {
	    jQuery('#sendresetpasswordemail_username').val(jQuery.trim(jQuery('#sendresetpasswordemail_username').val()));
		
		if(validatorResetPasswordForm.form()) {
			var ajaxRequest = {
				type: 'GET',
				url: URLS.AUTH_SEND_PASSWORD_RESET_EMAIL_URL + "/" + SETTINGS.DEFAULT_VERSION + "/" + SETTINGS.DEFAULT_LANG + "/" + jQuery('#sendresetpasswordemail_username').val(), 
				async : true,
				cache : false,
				beforeSend: function() {
					jQuery.blockUI({message: MESSAGES.STATUS.AJAX_LOADING});     
				},
				complete : function(){ 
				},
				error: handleResetPasswordRespOnError,
				success: showResetPasswordRespOnSuccess
			};
			var AjaxResult = jQuery.ajax(ajaxRequest);
		} else {
			return false;
		}
		jQuery('#password').removeClass("ignore");
		return false;
	});  
}); 