function SubmissionHistoryClass() {};
SubmissionHistoryClass.prototype.getSubHistoryAjaxRequest = function() {
	var ajaxReqModal=  {	type: 'GET',
		url: URLS.GET_SUBMISSION_HISTORY_REST_SERVICE_URL, 
		data: '',  
		async : true, 
		cache : false,
		contentType: SETTINGS.CONTENT_TYPE,   
		complete : function(){
			jQuery.unblockUI();
		}, 
		error: handleSubHistoryRespOnError,
		success: handleSubHistoryRespOnSuccess
	};

	return ajaxReqModal;

}

function revealSubmissionHistory(){

	priorityLevel = 1;
	maxLevel = 4;
	detail = 0;
	maxDetail = 2;

	var objSubHistory = new SubmissionHistoryClass();

	var ajaxReq= objSubHistory.getSubHistoryAjaxRequest();
	
    var trackingNumber = jQuery('#trackingNumber').val();
	ajaxReq.url = ajaxReq.url + '/1/en_US/'+ trackingNumber;
	var AjaxResult = jQuery.ajax(ajaxReq);
	
	$("#submissionHistoryPanel").reveal();   

}
function formatSubmissionHistory() {
 

}
function handleSubHistoryRespOnSuccess( data, statusCode, xhr ) {
	if(data.status !== 'undefined' && data.status == "SUCCESS") {
		loadSubmissionHistoryContent(data);
        formatSubmissionHistory();
	} else {
		var message = MESSAGES.ERROR.TECHNICAL_ERROR;
		$("#submissionHistoryContent").html("<label>"+message+"</label>").addClass( "error");
	}
}

function handleSubHistoryRespOnError( jqXHR, errorType, exception ) {
	var message = MESSAGES.ERROR.TECHNICAL_ERROR;

	try{					
		if(jqXHR.responseText !== 'undefined' && jqXHR.responseText != null)
		{
			var data = JSON.parse(jqXHR.responseText);
			if(hasUserAuthenticated(jqXHR, false) == false  ) {
				message = MESSAGES.STATUS.USER_SESSION_EXPIRED;
			} else if(hasUserAuthorized(jqXHR) == false ) {
				message = MESSAGES.STATUS.RESOURCE_ACCESS_DENIED;
			} else if(data.status != null && data.status == 'ERROR') {         	
 				message = data.errorCode + "<br />Details: " + data.errorDetails;
			}
			message = "Could not complete requested operation.<br />Error: " + message
		}
	} catch(e) {
		message =MESSAGES.ERROR.TECHNICAL_ERROR;
	}
	$('#submissionHistoryContent').css('overflow', 'hidden');
	$("#submissionHistoryContent").html("<label>"+message+"</label>").addClass( "error");

}

var priorityLevel = 1;
var maxLevel = 4;
var detail = 0;
var maxDetail = 2;
function toggle_history_block(objectId)
{
    var aReturn=document.getElementsByTagName("DIV");
    var firstRecord = true;
    var showDetails = true;
    for (var i = 0 ; i < aReturn.length; i++)
    {
        if (aReturn[i].className.indexOf("history") != -1)
        {
            if (aReturn[i].id == objectId)
            { // record is detail
                if(firstRecord)
                {
                    firstRecord = false;
                    if(aReturn[i].style.display != "none")
                        showDetails = false;
                }
                if (showDetails && aReturn[i].className.indexOf("detail1") != -1)
                {
                    aReturn[i].style.display = "block";
                }
                else
                {
                    aReturn[i].style.display = "none";
                }
            }
        }
    }
}
function increase_detail()
{
    if (detail < maxDetail)
    {
        detail++;
        if (detail == maxDetail )
        {
            document.getElementById("detailPlus").src="images/gray_add.gif";
        }
    }
    document.getElementById("detailMinus").src="images/grn_minus.gif";
    show_history_events();
}
function decrease_detail()
{
    if (detail > 0)
    {
        detail--;
        if (detail == 0 )
        {
            document.getElementById("detailMinus").src="images/gray_minus.gif";
        }
    }
    document.getElementById("detailPlus").src="images/grn_add.gif";
    show_history_events();
}
function show_detail()
{
    var aReturn=document.getElementsByTagName("DIV");
    for (var i = 0 ; i < aReturn.length; i++)
    {
        if (aReturn[i].className.indexOf("history") != -1)
        {
            if (aReturn[i].className.indexOf("detail") != -1)
            {  
                var detailIndex = aReturn[i].className.indexOf("detail") + 6;
                detailIndex = parseInt(aReturn[i].className.charAt(detailIndex));
                if (detailIndex <= detail && aReturn[i-1].style.display != "none")
                {
                    aReturn[i].style.display = "block";
                }
                else
                {
                    aReturn[i].style.display = "none";
                }
            }
        }
    }
}
var filter_other = true;
var filter_contacts = true;
var filter_viewed = true;
var filter_system = true;
function toggleFilterBoxes()
{
    var show_all = document.getElementById('showall_filter');
    if(show_all.checked)
    {
        document.getElementById('system_filter').disabled=true;
        document.getElementById('contacts_filter').disabled=true;
        document.getElementById('viewedonly_filter').disabled=true;
        filter_other = true;
        filter_contacts = true;
        filter_viewed = true;
        filter_system = true;
    }
    else
    {
        document.getElementById('system_filter').disabled=false;
        document.getElementById('contacts_filter').disabled=false;
        document.getElementById('viewedonly_filter').disabled=false;
        filter_other = false;
        filter_contacts = document.getElementById('contacts_filter').checked;
        filter_viewed = document.getElementById('viewedonly_filter').checked;
        filter_system = document.getElementById('system_filter').checked;
    }
    show_history_events();
    jQuery(window).scrollTop(0);
}
function show_class_display()
{
    clear_dates();  
     

    var aReturn=document.getElementsByTagName("DIV");
    for (var i = 0 ; i < aReturn.length; i++)
    {
        if (aReturn[i].className.indexOf("history") != -1)
        {
            var priorityIndex = aReturn[i].className.indexOf("priority") + 8;
            priorityIndex = parseInt(aReturn[i].className.charAt(priorityIndex));
            if(priorityIndex <= priorityLevel)
            {
                // Do not use else because one event can be in multiple categories
                if (filter_viewed && aReturn[i].className.indexOf('viewedonly') != -1)
                {
                    aReturn[i].style.display = "block";
                }
                if (filter_contacts && aReturn[i].className.indexOf('contacts') != -1)
                {
                    aReturn[i].style.display = "block";
                }
                if (filter_system && aReturn[i].className.indexOf('system') != -1)
                {
                    aReturn[i].style.display = "block";
                }
                if (filter_other && aReturn[i].className.indexOf('otherHistory') != -1)
                {
                    aReturn[i].style.display = "block";
                }
            }
        }
    }
    show_detail();
}
function clear_dates()
{
    var aReturn=document.getElementsByTagName("DIV");
    for (var i = 0 ; i < aReturn.length; i++)
    {
        if (aReturn[i].className.indexOf("history") != -1)
        {
            aReturn[i].style.display = "none";
        }
    }
}
function increase_priorities()
{
    if (priorityLevel < maxLevel )
    {
        priorityLevel++;
        if (priorityLevel == maxLevel )
        {
            document.getElementById("statusPlus").src="images/gray_add.gif";
        }
    }
    document.getElementById("statusMinus").src="images/grn_minus.gif";
    show_history_events();
}
function decrease_priorities()
{
    if (priorityLevel > 1)
    {
        priorityLevel--;
        if (priorityLevel == 1 )
        {
            document.getElementById("statusMinus").src="images/gray_minus.gif";
        }
    }
    document.getElementById("statusPlus").src="images/grn_add.gif";
    show_history_events();
}
function show_history_events()
{
    var aReturn=document.getElementsByTagName("DIV");
    for (var i = 0 ; i < aReturn.length; i++)
    {
        if (aReturn[i].className.indexOf("history") != -1)
        {
            var priorityIndex = aReturn[i].className.indexOf("priority") + 8;
            priorityIndex = parseInt(aReturn[i].className.charAt(priorityIndex));
            if(priorityIndex <= priorityLevel
               && (filter_other
                   || (filter_viewed && aReturn[i].className.indexOf('viewedonly') != -1)
                   || (filter_system && aReturn[i].className.indexOf('system') != -1)
                   || (filter_contacts && aReturn[i].className.indexOf('contacts') != -1)))
            {
                if (aReturn[i].className.indexOf("detail") != -1)
                {   
                    var detailIndex = aReturn[i].className.indexOf("detail") + 6;
                    detailIndex = parseInt(aReturn[i].className.charAt(detailIndex));
                    if (detailIndex <= detail)
                    {
                        aReturn[i].style.display = "block";
                    }
                    else
                    {
                        aReturn[i].style.display = "none";
                    }
                }
                else
                {    
                    aReturn[i].style.display = "block";
                }
            }
            else
            {
                aReturn[i].style.display = "none";
            }
        }
    }
}


function loadSubmissionHistoryContent(data){ 

  var historyHTMLContent = '<!-- Submission History -->\
    <!-- Each row is an individual table -->\
	<table style="width:100%;border-spacing:0;padding:0;border:0px">\
		<td valign="top" style="width:100%;background-color:#FFFFFF">\
		  <table style="width:100%;margin:0px;border-top:1px solid #666;border-bottom:2px solid #666;background-color:#B6CBD3">\
			<tr>\
			  <td style="background-color:#B6CBD3" width="57%"><strong><img id="statusMinus" src="images/gray_minus.gif" width="16" height="16" align="absbottom" onClick="decrease_priorities();show_detail()">&nbsp;Status&nbsp;<img id="statusPlus" src="images/grn_add.gif" width="16" height="16" align="absbottom" onClick="increase_priorities();show_detail()"></strong></td>\
			  <td style="background-color:#B6CBD3" width="43%"><strong><img id="detailMinus" src="images/gray_minus.gif" width="16" height="16" align="absbottom" onclick="decrease_detail()">&nbsp;Detail&nbsp;<img id="detailPlus" src="images/grn_add.gif" width="16" height="16" align="absbottom" onclick="increase_detail()"></strong></td>\
			</tr>\
		  </table>';
		$.each(data.submissionHistory.CurrentTimeLineEvents, function(i, event) { 
			var currentBackground = (i%2 == 0) ? "EEEEEE" : "FFFFFF" ;
			var currentBlock = "timelineBlock_" + i;
			var currentClass = "" + event.Priority + " " + event.CategoriesString;
			historyHTMLContent += '\
			<div class="history ' + currentClass + ( (event.Priority != 'priority1')?'" style="display:none;"' : '"') + '>\
				<table id="tblSubHistoryCurrentTimeLineEvents" style="width:100%;margin:0px;background-color:#'+ currentBackground + '">\
					<tr style="background-color:#' + currentBackground +'" onClick="toggle_history_block(\'' + currentBlock + '\')"\
						onmouseover="this.style.backgroundColor=\'#d8f0f8\'"\
						onmouseout="this.style.backgroundColor=\'#' + currentBackground + '\'">\
						<td width="57%">' + getNonNullValue(event.CreatedDate) + '</td>\
						<td width="43%">' + getNonNullValue(event.Summary) + '</td>\
					</tr>\
				</table>\
			</div>';
			
			if(typeof event.Comments !== "undefined" && event.Comments != "") {
				historyHTMLContent += '\
				<div align="right" id="' + currentBlock + '" style="display:none;" class="history ' + currentClass + ' detail1">\
					<table id="tblSubHistoryEventComments" bgcolor="#' + currentBackground + '" style="width:100%;margin:0px;background-color:#' + currentBackground + '">\
						<tr style="background-color:#'+ currentBackground + '">\
							<td width="8%">&nbsp;</td>\
							<td width="92%" align="left">' + getNonNullValue(event.Comments) + '</td>\
						</tr>\
					</table>\
				</div>';
			}
			
			$.each(event.Details, function(i, eventDetail) { 
				historyHTMLContent += '\
				<div align="right" id="' + currentBlock + '" style="display:none;" class="history '+ currentClass + ' ' + eventDetail.DetailLevel + '">\
					<table id="tblSubHistoryEventDetails" style="width:100%;margin:0px;background-color:#' + currentBackground + '">\
						<tr style="background-color:#' + currentBackground + '">\
							<td width="8%">&nbsp;</td>\
							<td width="55%" align="left">' + getNonNullValue(eventDetail.DetailField) + '</td>\
							<td width="37%" align="left">' + getNonNullValue(eventDetail.Value) + '</td>\
						</tr>\
					</table>\
				</div>';
			});
		}); 
		
		historyHTMLContent += '<!-- History Control Panel -->\
		<table style="width:100%;margin:0px;border-bottom:2px solid #666;border-top:2px solid #666;background-color:#B6CBD3">\
		  <tr style="background-color:#EEEEEE">\
			<td valign="middle" style="background-color:#B6CBD3">\
			  &nbsp;Filter: &nbsp;\
			  <input type="checkbox" id="showall_filter" name="showall"  value="showall" onclick="toggleFilterBoxes();" CHECKED>All&nbsp;&nbsp;\
			  <input type="checkbox" id="contacts_filter" name="contacts" value="contacts" onclick="filter_contacts=this.checked;show_history_events();" CHECKED>Contacts&nbsp;&nbsp;\
			  <input type="checkbox" id="system_filter" name="system" value="system" onclick="filter_system=this.checked;show_history_events();" CHECKED>System&nbsp;&nbsp;\
			  <input type="checkbox" id="viewedonly_filter" name="viewedonly" value="viewedonly" onclick="filter_viewed=this.checked;show_history_events();" CHECKED>Viewed Only &nbsp;&nbsp;&nbsp;\
			</td>\
		  </tr>\
		</table>\
	  </td>\
	</table>\
	';

	$("#submissionHistoryContent").html(historyHTMLContent);

}