function loadUserDetails(user) {
	jQuery('#email').html(getNonNullValue(user.consumerDemog["primaryEmail"]));
	jQuery('#firstName').html(getNonNullValue(user.consumerDemog["firstName"]));
	jQuery('#lastName').html(getNonNullValue(user.consumerDemog["lastName"]));
	jQuery('#address1').html(getNonNullValue(user.consumerDemog.addressList[0].streetAddress1));
	jQuery('#address2').html(getNonNullValue(user.consumerDemog.addressList[0].streetAddress2));
	jQuery('#city').html(getNonNullValue(user.consumerDemog.addressList[0].city));
	jQuery('#state').html(getNonNullValue(user.consumerDemog.addressList[0].state));
	jQuery('#zip').html(getNonNullValue(user.consumerDemog.addressList[0].postalCode));
	jQuery('#userName').html(getNonNullValue(user["userName"]));
	jQuery('#group').html(getNonNullValue(user["groupName"]));

	if(getNonNullValue(user["status"]) != "ACTIVE"){
		jQuery('#status').prop( "checked", true );
	}
	
	var userEnabledStatus='Enabled';
	if(getNonNullValue(user["status"]) != 'ACTIVE') {
			userEnabledStatus ='Disabled';
	}
	if(getNonNullValue(user["locked"]) == 'YES') {
			userEnabledStatus ='Locked, '+userEnabledStatus;
	}
	jQuery("#statusLbl").html(userEnabledStatus);

}

function showRetrieveUserRespOnSuccess( data, statusCode, xhr ) {
	//Triggered after a successful response from server
	if(data.status == "SUCCESS" || data.status == "SUCESS" ) {
		loadUserDetails(data.userVO);
		saveTableResultsInStore(data);
	}
}

function showErrorMsg(message) {

	jQuery('#userErrorPanel').show();
	jQuery('#userErrorMsg').html(message);
}

function handleRetrieveUserRespOnError( jqXHR, errorType, exception ) {

	var message = MESSAGES.ERROR.TECHNICAL_ERROR;
	if(hasUserAuthenticated(jqXHR, false) == false  ) {
		message = MESSAGES.STATUS.USER_SESSION_EXPIRED;
	} else if(hasUserAuthorized(jqXHR) == false  ) {
		message = MESSAGES.STATUS.RESOURCE_ACCESS_DENIED;
	}
	showErrorMsg(message);
}

jQuery(document).ready(function() {

	checkUserSession(true);
	welcomeUser();
displayAdminNav();
		var ajaxRequest = {
			type: 'GET',
			url: '',
			datType: 'json',
			async : true, 
			cache : false,
			contentType: SETTINGS.CONTENT_TYPE,
	        complete : function(){
				jQuery.unblockUI();
	        }, 
			error: handleRetrieveUserRespOnError,
			success: showRetrieveUserRespOnSuccess
		};


		//Set Ajax Request Data
		ajaxRequest.url=URLS.VIEW_USER_REST_SERVICE_URL+'/'+SETTINGS.DEFAULT_VERSION+'/'+SETTINGS.DEFAULT_LANG+'/'+GetURLParameter('userName')+'/VERIZON';
		var AjaxResult = jQuery.ajax(ajaxRequest);

});  